###############################################################################
# BoardIndex.pl                                                               #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.1                                                    #
# Released:       November 8, 2005                                            #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2005 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
###############################################################################

$boardindexplver = 'YaBB 2.1 $Revision: 1.4 $';

if ($action eq 'detailedversion') { return 1; }

LoadLanguage("BoardIndex");
LoadLanguage("AdminCenter_Update");
if (-e "$vardir/acup_dim.txt") { require "$vardir/acup_dim.txt"; }
LoadLanguage("SubBoard");
## start hidden user mod part 6 - load hidden_user.lng file ##
LoadLanguage("hidden_user");
## end hidden user mod part 6 ##
require "$templatesdir/$useboard/BoardIndex.template";

sub Del_Max_IM {
	fopen(DELMAXIM, "$memberdir/$username.msg");
	@messages = <DELMAXIM>;
	fclose(DELMAXIM);

	fopen(DELMAXIM, ">$memberdir/$username.msg", 1);
	for ($a = 0; $a < @messages; $a++) {
		chomp $messages[$a];
		if ($a < $numibox) { print DELMAXIM "$messages[$a]\n"; }
	}
	fclose(DELMAXIM);
}

sub Del_Max_IMOUT {
	fopen(DELMAXIMOUT, "$memberdir/$username.outbox");
	@omessages = <DELMAXIMOUT>;
	fclose(DELMAXIMOUT);

	fopen(DELMAXIMOUT, ">$memberdir/$username.outbox", 1);
	for ($a = 0; $a < @omessages; $a++) {
		chomp $omessages[$a];
		if ($a < $numobox) { print DELMAXIMOUT "$omessages[$a]\n"; }
	}
	fclose(DELMAXIMOUT);
}

sub Del_Max_STORE {
	fopen(DELMAXIMSTORE, "$memberdir/$username.imstore");
	@smessages = <DELMAXIMSTORE>;
	fclose(DELMAXIMSTORE);

	fopen(DELMAXIMSTORE, ">$memberdir/$username.imstore", 1);
	for ($a = 0; $a < @smessages; $a++) {
		chomp $smessages[$a];
		if ($a < $numstore) { print DELMAXIMSTORE "$smessages[$a]\n"; }
	}
	fclose(DELMAXIMSTORE);
}

sub BoardIndex {
	my ($lspostid, $lspostbd, $lssub, $lsposttime, $lsposter, $lsreply, $lsdatetime, $lastthreadtime, @goodboards, @loadboards);
	my ($memcount, $latestmember) = &MembershipGet;
	chomp $latestmember;
	$totalm         = 0;
	$totalt         = 0;
	$lastposttime   = 0;
	$lastthreadtime = 0;

	my $checkadded = 0;
	$users     = qq~<span class="small">~;
	$guestlist = qq~<span class="small">~;
## start hidden user mod part 1 - initialize hidden user counter ##
    $guests   = 0;
    $numusers = 0;
    if($allow_hidden eq 1){ 
       $numhidden = 0;
       $num_hidden_admin = 0;
       $hidden = qq~<span class="small">~;
    }
## end hidden user mod part 1 ##
	fopen(VARLOG, "$vardir/log.txt");
	@entries = <VARLOG>;
	fclose(VARLOG);

	foreach $curentry (@entries) {
		chomp $curentry;
		($name, $value, $last_ip) = split(/\|/, $curentry);
		if (!$last_ip) { $last_ip = qq~</i></span><span class="error">$boardindex_txt{'no_ip'}</span><span class="small"><i>~; }
		if ($name) {
			if (-e ("$memberdir/$name.vars")) {
				unless (${$uid.$name}{'realname'}) { &LoadUser($name); }
				&LoadMiniUser($name);
## start hidden user mod part 2 - count hidden users online and/or make them visible to admin/gmod ##
				if($allow_hidden eq 1 && ${$uid.$name}{'hide_me'} eq "on"){
				   if($count_admin_gmod ne 1){
				      if(${$uid.$name}{'position'} ne "Administrator" && ${$uid.$name}{'position'} ne "Global Moderator"){
					     $numhidden++;
				      }
					  else{$num_hidden_admin++;}
				   }
				   else{$numhidden++;}
				   if(($iamadmin && $show_online_ip_admin) || ($iamgmod && $show_online_ip_gmod)) {
				      $hidden .= qq~<i>$link{$name} ($last_ip)</i>~;
					  $hidden .= qq~, ~;
				   }
				}
				else {
				$numusers++;
				$users .= qq~$link{$name}~;
				if(($iamadmin && $show_online_ip_admin) || ($iamgmod && $show_online_ip_gmod)) {
					$users .= qq~<i> ($last_ip)</i>~;
				}
				$users .= qq~, ~;
				}
## end hidden user mod part 2 ##
			} else {
				$guests++;
				if (($iamadmin && $show_online_ip_admin) || ($iamgmod && $show_online_ip_gmod)) {
					$guestlist .= qq~<i>$last_ip</i>, ~;
				}
			}
		}
	}
	$users =~ s~, \Z~~;
	$users .= qq~</span>~;
	if ($numusers) { $users .= qq~<br />~; }
	$guestlist =~ s~, \Z~~;
	$guestlist .= qq~</span>~;
## start hidden user mod part 3 - assign html ##
	if($allow_hidden eq 1 && ($iamadmin || $iamgmod) && (($num_hidden_admin || $numhidden) ne 0)) {
	   $hidden =~ s~, \Z~~;
	   $hidden .= qq~</span>~;
	   $hidden .= qq~<br />~;
	}
    else{$hidden = qq~<!-- no hidden users -->~;}
## end hidden user mod part 3 ##

	$curforumurl = $curposlinks ? qq~<a href="$scripturl" class="nav">$mbname</a>~ : $mbname;
	if (!$INFO{'catselect'}) {
	} else {
		($tmpcat, $tmpmod, $tmpcol) = split(/\|/, $catinfo{ $INFO{'catselect'} });
		$curforumurl = qq~<a href="$scripturl" class="nav">$mbname</a> &rsaquo; $tmpcat~;
	}

	if (!$iamguest) {
		&Collapse_Load;
	}

	# first get all the boards based on the categories found in forum.master
	foreach $catid (@categoryorder) {
		if ($INFO{'catselect'} ne $catid && $INFO{'catselect'}) { next; }
		$boardlist = $cat{$catid};
		(@bdlist) = split(/\,/, $boardlist);
		my ($catname, $catperms, $catallowcol) = split(/\|/, $catinfo{"$catid"});

		# Category Permissions Check
		my $access = &CatAccess($catperms);
		if (!$access) { next; }
		$cat_boardcnt{$catid} = 0;

		# next determine all the boards a user has access to
		foreach $curboard (@bdlist) {

			# now fill all the neccesary hashes to show all board index stuff
			chomp $curboard;
			if (!exists $board{$curboard}) {
				&gostRemove($catid, $curboard);
				next;
			}

			# hide the actual global announcement board for all normal users but admins and gmods
			if ($annboard eq $curboard && !$iamadmin && !$iamgmod) { next; }

			my ($boardname, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
			my $access = &AccessCheck($curboard, '', $boardperms);
			if (!$iamadmin && $access ne "granted" && $boardview != 1) { next; }
			push(@goodboards, "$catid|$curboard");
			push(@loadboards, $curboard);
			$cat_boardcnt{$catid}++;
		}
	}
	foreach $topboard (@loadboards) {
		if ($sblist{"$topboard"} eq "") { next; }
		@subboard_lists = split(/\,/, $sblist{"$topboard"});
		push(@loadsubboards, @subboard_lists);
	}
	foreach $goodtopboard (@goodboards) {
		($brdcat, $topbrd) = split(/\|/, $goodtopboard);
		if ($sblist{"$topbrd"} eq "") { next; }
		@subboard_lists = split(/\,/, $sblist{"$topbrd"});
		foreach $goodsbrd (@subboard_lists) {
			push(@goodsubboards, "$brdcat|$goodsbrd");
		}
	}
	&BoardTotals("load", @loadboards);
if(-e("$vardir/RatingConf.txt"))  { require "$vardir/RatingConf.txt"; LoadLanguage("RateIT"); }
if ($enable_ratings) {
	my ($dummy2, $cntrateboard, $cntbrateenable, $cntautoapplyrate, $cntviewrateindex, $cntratestar, $cntrategraph, $cntboardratelst);
	fopen(RATECONTROL, "+<$boardsdir/rate.cntr");
	seek RATECONTROL, 0, 0;
	my @boardratecontrols = <RATECONTROL>;
	fclose(RATECONTROL);
	foreach my $boardrateline (@boardratecontrols) {
		$boardrateline =~ s/[\r\n]//g;
		chomp $boardrateline;
		($dummy2, $cntrateboard, $cntbrateenable, $cntautoapplyrate, $cntviewrateindex, $cntratestar, $cntrategraph, $cntboardratelst) = split(/\|/, $boardrateline);
		${$uid.$cntrateboard}{'brate_enable'} = $cntbrateenable;
		${$uid.$cntrateboard}{'apply_arate'} = $cntautoapplyrate;
		${$uid.$cntrateboard}{'view_arate'} = $cntviewrateindex;
		${$uid.$cntrateboard}{'view_ratestar'} = $cntratestar;
		${$uid.$cntrateboard}{'view_rategraph'} = $cntrategraph;
		${$uid.$cntrateboard}{'view_bratelst'} = $cntboardratelst;
	}
}
	&BoardTotals("load",@loadsubboards);
	&getlog(@goodboards);
	foreach $curboard (@loadboards) {
		chomp $curboard;
		$lastposttime = ${$uid.$curboard}{'lastposttime'};
		${$uid.$curboard}{'lastposttime'} = ${$uid.$curboard}{'lastposttime'} eq 'N/A' || !${$uid.$curboard}{'lastposttime'} ? $boardindex_txt{'470'} : ${$uid.$curboard}{'lastposttime'};
		if (${$uid.$curboard}{'lastposttime'} != 0) { $lastposttime{$curboard} = &timeformat(${$uid.$curboard}{'lastposttime'}); }
		else { $lastposttime{$curboard} = $boardindex_txt{'470'}; }
		$lastpostrealtime{$curboard} = ${$uid.$curboard}{'lastposttime'} eq 'N/A' || !${$uid.$curboard}{'lastposttime'} ? '' : ${$uid.$curboard}{'lastposttime'};
		$lsreply{$curboard} = ${$uid.$curboard}{'lastreply'} + 1;
		if (${$uid.$curboard}{'lastposter'} =~ m~\AGuest-(.*)~) {
			${$uid.$curboard}{'lastposter'} = $1;
			$lastposterguest{$curboard} = 1;
		}
		${$uid.$curboard}{'lastposter'}   = ${$uid.$curboard}{'lastposter'} eq 'N/A' || !${$uid.$curboard}{'lastposter'} ? $boardindex_txt{'470'} : ${$uid.$curboard}{'lastposter'};
		${$uid.$curboard}{'messagecount'} = ${$uid.$curboard}{'messagecount'}        || 0;
		${$uid.$curboard}{'threadcount'}  = ${$uid.$curboard}{'threadcount'}         || 0;
		$totalmessagecount{"$curboard"} = ${$uid.$curboard}{'messagecount'};
		$totalthreadcount{"$curboard"} = ${$uid.$curboard}{'threadcount'};
		@subboard_lists = split(/\,/, $sblist{"$curboard"});
		foreach $subboard_list (@subboard_lists) {
			my ($subboard_name, $subboard_perms, $subboard_view) = split(/\|/, $board{"$subboard_list"});
			my $access = &AccessCheck($subboard_list, '', $subboard_perms);
			if (!$iamadmin && $access ne "granted" && $subboard_view != 1) {next;}
			$totalmessagecount{"$curboard"} += ${$uid.$subboard_list}{'messagecount'};
			$totalthreadcount{"$curboard"} += ${$uid.$subboard_list}{'threadcount'};
		}
		$totalm += $totalmessagecount{"$curboard"};
		$totalt += $totalthreadcount{"$curboard"};

		# hide hidden threads for ordinary members and guests
		$iammodhere = "";
		$bdmods     = ${$uid.$curboard}{'mods'};
		$bdmods =~ s/\, /\,/g;
		$bdmods =~ s/\ /\,/g;
		foreach $curuser (split(/\,/, $bdmods)) {
			if ($username eq $curuser) { $iammodhere = 1; }
		}
		if (!$iammodhere && !$iamadmin && !$iamgmod) {
			fopen(MNUM, "$boardsdir/$curboard.txt");
			@threadlist = <MNUM>;
			fclose(MNUM);
			my (@messarr) = split(/\|/, $threadlist[0]);
			$messagestate = pop(@messarr);
			if ($messagestate =~ /h/i) {
				${$uid.$curboard}{'lastpostid'}   = "";
				${$uid.$curboard}{'lastsubject'}  = "";
				${$uid.$curboard}{'lastreply'}    = "";
				${$uid.$curboard}{'lastposter'}   = qq~$boardindex_txt{'470'}~;
				${$uid.$curboard}{'lastposttime'} = "";
				$lastposttime{$curboard} = qq~$boardindex_txt{'470'}~;
				for ($i = 1; $i < @threadlist; $i++) {
					($messageid, $messagesubject, undef, undef, undef, undef, undef, undef, $messagestate) = split(/\|/, $threadlist[$i]);
					if ($messagestate !~ /h/i) {
						fopen(MDATA, "$datadir/$messageid.ctb");
						@threaddata = <MDATA>;
						fclose(MDATA);
						chomp @threaddata;
						${$uid.$curboard}{'lastpostid'}   = $messageid;
						${$uid.$curboard}{'lastsubject'}  = $messagesubject;
						${$uid.$curboard}{'lastreply'}    = $threaddata[1];
						${$uid.$curboard}{'lastposter'}   = $threaddata[3];
						${$uid.$curboard}{'lastposttime'} = $threaddata[4];
						$lastposttime{$curboard} = &timeformat($threaddata[4]);
						last;
					}
				}
			}
		}
	}
	foreach $catid (@categoryorder) {
		if ($INFO{'catselect'} ne $catid && $INFO{'catselect'}) { next; }
		$boardlist = $catbdlist{$catid};
		(@bdlist) = split(/\,/, $boardlist);
		my ($catname, $catperms, $catallowcol) = split(/\|/, $catinfo{"$catid"});

		# Category Permissions Check
		my $access = &CatAccess($catperms);
		if (!$access) { next; }

		foreach $curboard (@bdlist) {
			# now fill all the neccesary hashes to show all board index stuff
			chomp $curboard;
			if (!exists $board{$curboard}) {
				&gostRemove($catid, $curboard);
				next;
			}

			# hide the actual global announcement board for all normal users but admins and gmods
			if ($annboard eq $curboard && !$iamadmin && !$iamgmod) { next; }

			my ($boardname, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
			my $access = &AccessCheck($curboard, '', $boardperms);
			if (!$iamadmin && $access ne "granted" && $boardview != 1) { next; }

			if (${$uid.$curboard}{'lastposttime'} != 0) { $lastposttime{$curboard} = &timeformat(${$uid.$curboard}{'lastposttime'}); }
			else { $lastposttime{$curboard} = $boardindex_txt{'470'}; }

			# determine the true last post on all the boards a user has access to
			if (${$uid.$curboard}{'lastposttime'} > $lastthreadtime && $lastposttime{$curboard} ne $boardindex_txt{'470'}) {
				$lsdatetime     = $lastposttime{$curboard};
				$lsposter       = ${$uid.$curboard}{'lastposter'};
				$lssub          = ${$uid.$curboard}{'lastsubject'};
				$lspostid       = ${$uid.$curboard}{'lastpostid'};
				$lsreply        = ${$uid.$curboard}{'lastreply'};
				$lastthreadtime = ${$uid.$curboard}{'lastposttime'};
				$lspostbd       = $curboard;
			}
		}
	}

	foreach $catid (@categoryorder) {
		if ($INFO{'catselect'} ne $catid && $INFO{'catselect'}) { next; }
		my ($catname, $catperms, $catallowcol) = split(/\|/, $catinfo{"$catid"});
		&ToChars($catname);

		$cataccess = &CatAccess($catperms);
		if (!$cataccess) { next; }

		# Skip any empty categories.
		if ($cat_boardcnt{$catid} == 0) { next; }

		if (!$iamguest) {
			my $newmsg = 0;
			$newms{$catname}       = "";
			$newrowicon{$catname}  = "";
			$newrowstart{$catname} = "";
			$newrowend{$catname}   = "";

			if ($catallowcol) {
				$collapse_link = qq~<a href="$scripturl?action=collapse_cat;cat=$catid">~;
			} else {
				$collapse_link = qq~~;
			}

			# loop through any collapsed boards to find new posts in it and change the image to match
			if (!$catcol{$catid} && $INFO{'catselect'} eq '') {

				foreach my $boardinfo (@goodboards) {
					chomp $boardinfo;
					my ($testcat);
					($testcat, $curboard) = split(/\|/, $boardinfo);
					if ($testcat ne $catid) { next; }

					# as we fill the vars based on all boards we need to skip any cat already shown before
					my $dlp = $yyuserlog{$curboard} ? $yyuserlog{$curboard} : 0;
					if ($max_log_days_old && ${$uid.$curboard}{'lastposttime'} ne $boardindex_txt{'470'} && $dlp < $lastpostrealtime{$curboard} && ($dlp > $max_log_days_old * 86400 || $dlp == 0)) {
						my (undef, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
						if (&AccessCheck($curboard, '', $boardperms) eq "granted") { $newmsg = 1; }
					}
					@subboard_lists = split(/\,/, $sblist{"$curboard"});
					foreach $subboardlist (@subboard_lists) {
						my ($subboard_name, $subboard_perms, $subboard_view) = split(/\|/, $board{"$subboardlist"});
						my $access = &AccessCheck($subboard_list, '', $subboard_perms);
						if (!$iamadmin && $access ne "granted" && $subboard_view != 1) {next;}
						my $dlp = $yyuserlog{$subboardlist} ? $yyuserlog{$subboardlist} : 0;
						$lastpostrealtime{$subboardlist} = ${$uid.$subboardlist}{'lastposttime'} eq 'N/A' || ! ${$uid.$subboardlist}{'lastposttime'} ? '' : ${$uid.$subboardlist}{'lastposttime'};
						if( $max_log_days_old && ${$uid.$subboardlist}{'lastposttime'} ne $boardindex_txt{'470'} && !$iamguest && $dlp < $lastpostrealtime{$subboardlist} && ($dlp>$max_log_days_old*86400 || $dlp eq 0)) {
							$newmsg = 1; last;
						}
					}
				}
				$newrowstart{$catname} = qq~<tr><td colspan="5" class="$new_msg_bg" height="18"><span class="$new_msg_class">~;
				$newrowend{$catname}   = qq~</span></td></tr>~;
				if ($newmsg) {
					if ($catallowcol) {
						$hash{$catname}       = qq~ <img src="$imagesdir/cat_expand.gif" alt="$boardindex_exptxt{'1'}" border="0" /></a>~;
						$newrowicon{$catname} = qq~<img src="$imagesdir/on.gif" alt="$boardindex_txt{'333'}" border="0" style="margin-left: 4px; margin-right: 6px; vertical-align: middle;" />~;
						$newms{$catname}      = qq~$boardindex_exptxt{'5'}~;
					}
				} else {
					if ($catallowcol) {
						$hash{$catname}       = qq~ <img src="$imagesdir/cat_expand.gif" alt="$boardindex_exptxt{'1'}" border="0" /></a>~;
						$newrowicon{$catname} = qq~<img src="$imagesdir/off.gif" alt="$boardindex_txt{'334'}" border="0" style="margin-left: 4px; margin-right: 6px; vertical-align: middle;" />~;
						$newms{$catname}      = qq~$boardindex_exptxt{'6'}~;
					}
				}
			} else {
				if ($catallowcol) {
					if ($INFO{'catselect'} ne '') { $collapse_link = ""; $hash{$catname} = ""; }
					else { $hash{$catname} = qq~<img src="$imagesdir/cat_collapse.gif" alt="$boardindex_exptxt{'2'}" border="0" /></a>~; }
				}
			}
			$catlink = qq~$collapse_link $hash{$catname} <a href="$scripturl?catselect=$catid" title="$boardindex_txt{'797'} $catname">$catname</a>~;
		} else {
			$catlink = qq~<a href="$scripturl?catselect=$catid">$catname</a>~;
		}
		$templatecat = $catheader;
		$templatecat =~ s/<yabb catlink>/$catlink/g;
		$templatecat =~ s/<yabb newmsg start>/$newrowstart{$catname}/g;
		$templatecat =~ s/<yabb newmsg icon>/$newrowicon{$catname}/g;
		$templatecat =~ s/<yabb newmsg>/$newms{$catname}/g;
		$templatecat =~ s/<yabb newmsg end>/$newrowend{$catname}/g;
		$iammod = "";
		$tmptemplateblock .= $templatecat;
		## loop through any non collapsed boards to show the board index ##
		if ($catcol{$catid} || $INFO{'catselect'} ne '' || $iamguest) {
			foreach my $boardinfo (@goodboards) {
				chomp $boardinfo;
				my ($testcat);
				($testcat, $curboard) = split(/\|/, $boardinfo);

				if ($testcat ne $catid) { next; }

				# as we fill the vars based on all boards we need to skip any cat already shown before
				if (${$uid.$curboard}{'ann'} == 1)  { ${$uid.$curboard}{'pic'} = "ann.gif"; }
				if (${$uid.$curboard}{'rbin'} == 1) { ${$uid.$curboard}{'pic'} = "recycle.gif"; }
				($boardname, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
				&ToChars($boardname);
				$INFO{'zeropost'} = 0;
				$zero             = "";
				$bdpic            = ${$uid.$curboard}{'pic'};
				$bddescr          = ${$uid.$curboard}{'description'};
				&ToChars($bddescr);
				$bdmods = ${$uid.$curboard}{'mods'};
				$bdmods =~ s/\, /\,/g;
				$bdmods =~ s/\ /\,/g;
				%moderators = ();

				foreach $curuser (split(/\,/, $bdmods)) {
					if ($username eq $curuser) { $iammod = 1; }
					&LoadUser($curuser);
					$moderators{$curuser} = ${$uid.$curuser}{'realname'};
				}
				$showmods = '';
				if    (scalar keys %moderators == 1) { $showmods = qq~$boardindex_txt{'298'}: ~; }
				elsif (scalar keys %moderators != 0) { $showmods = qq~$boardindex_txt{'63'}: ~; }
				while ($tmpa = each(%moderators)) {
					&FormatUserName($tmpa);
					$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tmpa}">$moderators{$tmpa}</a>, ~;
				}
				$showmods =~ s/, \Z//;

				&LoadUser($username);
				$bdmodgroups = ${$uid.$curboard}{'modgroups'};
				$bdmodgroups =~ s/\, /\,/g;
				%moderatorgroups = ();
				foreach $curgroup (split(/\,/, $bdmodgroups)) {
					if (${$uid.$username}{'position'} eq $curgroup) { $iammod = 1; }
					foreach $memberaddgroups (split(/\, /, ${$uid.$username}{'addgroups'})) {
						chomp $memberaddgroups;
						if ($memberaddgroups eq $curgroup) { $iammod = 1; last; }
					}
					($thismodgrp, undef) = split(/\|/, $NoPost{$curgroup}, 2);
					$moderatorgroups{$curgroup} = $thismodgrp;
				}

				$showmodgroups = '';
				if    (scalar keys %moderatorgroups == 1) { $showmodgroups = qq~$boardindex_txt{'298a'}: ~; }
				elsif (scalar keys %moderatorgroups != 0) { $showmodgroups = qq~$boardindex_txt{'63a'}: ~; }
				while ($tmpa = each(%moderatorgroups)) {
					$showmodgroups .= qq~$moderatorgroups{$tmpa}, ~;
				}
				$showmodgroups =~ s/, \Z//;
				if ($sboard{"$curboard"} ne "") {
					my @subboard = split(/\,/, $sboard{"$curboard"});
					$commacount = 1;
					$subboardlist = "";
					foreach $sub (@subboard) {
						my ($subboard_name, $subboard_perms, $subboard_view) = split(/\|/, $board{"$sub"});
						my $access = &AccessCheck($sub, '', $subboard_perms);
						if (!$iamadmin && $access ne "granted" && $subboard_view != 1) {next;}
						if ($commacount++ == 1) {
							$subboardlist .= qq~<a href="$scripturl?board=$sub" class="nav">$subboard_name</a>~;
						} else {
							$subboardlist .= qq~, <a href="$scripturl?board=$sub" class="nav">$subboard_name</a>~;
						}
					}
					if ( $subboardlist ne "" ) {
						$subcount = @subboard;
						if ($subcount == 1) { $subboards = "$subboard_txt{'6'}: $subboardlist"; }
						else {$subboards = "$subboard_txt{'7'}: $subboardlist"; }
					} else { $subboards = ""; }
				} else { $subboards = ""; }

				if ($showmodgroups eq "" && $showmods eq "" && $subboards eq "") { $subboards = qq~<br />~; }
				if ($showmodgroups eq "" && $showmods ne "" && $subboards ne "") { $showmods .= qq~<br />~; }
				if ($showmodgroups ne "" && $showmods ne "" && $subboards eq "") { $showmods .= qq~<br />~; }
				if ($showmodgroups ne "" && $showmods eq "" && $subboards ne "") { $showmodgroups .= qq~<br />~; }
				if ($showmodgroups ne "" && $showmods ne "" && $subboards ne "") { $showmods .= qq~<br />~; $showmodgroups .= qq~<br />~; }

				my $dlp = $yyuserlog{$curboard} ? $yyuserlog{$curboard} : 0;
				if ($max_log_days_old && ${$uid.$curboard}{'lastposttime'} ne $boardindex_txt{'470'} && !$iamguest && $dlp < $lastpostrealtime{$curboard} && ($dlp > $max_log_days_old * 86400 || $dlp == 0)) {
					my (undef, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
					if (&AccessCheck($curboard, '', $boardperms) eq "granted") {
						$new = qq~<img src="$imagesdir/on.gif" alt="$boardindex_txt{'333'}" border="0" />~;
					} else {
						$new = qq~<img src="$imagesdir/off.gif" alt="$boardindex_txt{'334'}" border="0" />~;
					}
				} else {
					$new = qq~<img src="$imagesdir/off.gif" alt="$boardindex_txt{'334'}" border="0" />~;
				}
				@subboard_lists = split(/\,/, $sblist{"$curboard"});
				foreach $subboardlist (@subboard_lists) {
					my ($subboard_name, $subboard_perms, $subboard_view) = split(/\|/, $board{"$subboardlist"});
					my $access = &AccessCheck($subboard_list, '', $subboard_perms);
					if (!$iamadmin && $access ne "granted" && $subboard_view != 1) {next;}
					my $dlp = $yyuserlog{$subboardlist} ? $yyuserlog{$subboardlist} : 0;
					$lastpostrealtime{$subboardlist} = ${$uid.$subboardlist}{'lastposttime'} eq 'N/A' || ! ${$uid.$subboardlist}{'lastposttime'} ? '' : ${$uid.$subboardlist}{'lastposttime'};
					if( $max_log_days_old && ${$uid.$subboardlist}{'lastposttime'} ne $boardindex_txt{'470'} && !$iamguest && $dlp < $lastpostrealtime{$subboardlist} && ($dlp>$max_log_days_old*86400 || $dlp eq 0)) {
						$new = qq~<img src="$imagesdir/on.gif" alt="$boardindex_txt{'333'}" border="0" />~; last;
					}
				}
				if (${$uid.$curboard}{'ann'} == 1)  { $new = qq~<img src="$imagesdir/ann.gif" alt="" border="0" />~; }
				if (${$uid.$curboard}{'rbin'} == 1) { $new = qq~<img src="$imagesdir/recycle.gif" alt="" border="0" />~; }

				$lastposter = ${$uid.$curboard}{'lastposter'};
				$lastposter =~ s~\AGuest-(.*)~$1~i;

				unless ($lastposterguest{$curboard} || ${$uid.$curboard}{'lastposter'} eq $boardindex_txt{'470'}) {
					&LoadUser($lastposter);
					$registrationdate = ${$uid.$lastposter}{'regtime'};

					$messagedate = ${$uid.$curboard}{'lastposttime'};

					if ((${$uid.$lastposter}{'regdate'} && $messagedate > $registrationdate) || ${$uid.$lastposter}{'status'} eq "Administrator" || ${$uid.$lastposter}{'status'} eq "Global Moderator") {
						$lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposter">${$uid.$lastposter}{'realname'}</a>~;
					} else {
						$lastposter .= qq~ - $boardindex_txt{'470a'}~;
					}
				}
				${$uid.$curboard}{'lastposter'}   ||= $boardindex_txt{'470'};
				${$uid.$curboard}{'lastposttime'} ||= $boardindex_txt{'470'};

				if ($bdpic =~ /\//i) { $bdpic = qq~ <img src="$bdpic" alt="" border="0" align="middle" /> ~; }
				elsif ($bdpic) { $bdpic = qq~ <img src="$imagesdir/$bdpic" alt="" border="0" align="middle" /> ~; }

				my $templateblock = $boardblock;

				if (!$topiccut) { $topiccut = 15; }
				my $lasttopictxt = ${$uid.$curboard}{'lastsubject'};
				$lasttopictxt =~ s/\A\[m\]/$maintxt{'758'}/;

				# Censor the subject
				&LoadCensorList;
				$lasttopictxt = &Censor($lasttopictxt);
				$fulltopictext = qq~$lasttopictxt~;

				if (${$uid.$curboard}{'lastreply'} ne "") {
					$lastpostlink = qq~<a href="$scripturl?num=${$uid.$curboard}{'lastpostid'}/${$uid.$curboard}{'lastreply'}#${$uid.$curboard}{'lastreply'}">$img{'lastpost'}</a> $lastposttime{$curboard}~;
				} else {
					$lastpostlink = qq~$img{'lastpost'} $boardindex_txt{'470'}~;
				}

				$convertstr = $lasttopictxt;
				$convertcut = $topiccut;
				&FromHTML($convertstr);
				&CountChars;
				my $lasttopictxt = $convertstr;
				&ToChars($lasttopictxt);
				&ToChars($fulltopictext);

				if ($cliped) { $lasttopictxt .= "..."; }

				$lasttopictxt =~ s/  / \&nbsp;/g;
				$lasttopictxt =~ s/</&lt;/g;
				$lasttopictxt =~ s/>/&gt;/g;
				$lasttopictxt =~ s/\|/\&#124;/g;

				$fulltopictext =~ s/</&lt;/g;
				$fulltopictext =~ s/>/&gt;/g;
				$fulltopictext =~ s/\|/\&#124;/g;

				# Determine last post in subboards
				if ($sboard{"$curboard"} ne "") {
					$sblastpost = 0;
					@allsboards = split(/\,/, $sblist{"$curboard"});
					foreach $sb (@allsboards) {
						if (${$uid.$sb}{'lastposttime'} eq "") { next; }
						if (${$uid.$sb}{'lastposttime'} > $sblastpost) {
							$sbdatetime     = $lastposttime{$sb};
							$sblastposter   = ${$uid.$sb}{'lastposter'};
							$sblastpostsub  = ${$uid.$sb}{'lastsubject'};
							$sblastpostid   = ${$uid.$sb}{'lastpostid'};
							$sblastreply    = ${$uid.$sb}{'lastreply'};
							$sblastpost     = ${$uid.$sb}{'lastposttime'};
							$sblastpostbd   = $sb;
						}
					}
					$sblastposter = ${$uid.$sblastpostbd}{'lastposter'};
					$sblastposter =~ s~\AGuest-(.*)~$1~i;

					if (${$uid.$sblastpostbd}{'lastposttime'} != 0) { $lastposttime{$sblastpostbd} = &timeformat(${$uid.$sblastpostbd}{'lastposttime'}); }
					else { $lastposttime{$sblastpostbd} = $boardindex_txt{'470'}; }

					unless ($lastposterguest{$sblastpostbd} || ${$uid.$sblastpostbd}{'lastposter'} eq $boardindex_txt{'470'}) {
						&LoadUser($sblastposter);
						$registrationdate = ${$uid.$sblastposter}{'regtime'};

						$sbmessagedate = ${$uid.$sblastpostbd}{'lastposttime'};

						if ((${$uid.$sblastposter}{'regdate'} && $sbmessagedate > $registrationdate) || ${$uid.$sblastposter}{'status'} eq "Administrator" || ${$uid.$sblastposter}{'status'} eq "Global Moderator") {
							$sblastposter = qq~<a href="$scripturl?action=viewprofile;username=$sblastposter">${$uid.$sblastposter}{'realname'}</a>~;
						} else {
							$sblastposter .= qq~ - $boardindex_txt{'470a'}~;
						}
					}
					${$uid.$sblastpostbd}{'lastposter'}   ||= $boardindex_txt{'470'};
					${$uid.$sblastpostbd}{'lastposttime'} ||= $boardindex_txt{'470'};
					if (!$topiccut) { $topiccut = 15; }
					my $sblasttopictxt = ${$uid.$sblastpostbd}{'lastsubject'};
					$sblasttopictxt =~ s/\A\[m\]/$maintxt{'758'}/;

					# Censor the subject
					&LoadCensorList;
					$sblasttopictxt = &Censor($sblasttopictxt);
					$sbfulltopictext = qq~$sblasttopictxt~;

					if (${$uid.$sblastpostbd}{'lastreply'} ne "") {
						$sblastpostlink = qq~<a href="$scripturl?num=${$uid.$sblastpostbd}{'lastpostid'}/${$uid.$sblastpostbd}{'lastreply'}#${$uid.$sblastpostbd}{'lastreply'}">$img{'lastpost'}</a> $lastposttime{$sblastpostbd}~;
					} else {
						$sblastpostlink = qq~$img{'lastpost'} $boardindex_txt{'470'}~;
					}

					$convertstr = $sblasttopictxt;
					$convertcut = $topiccut;
					&FromHTML($convertstr);
					&CountChars;
					my $sblasttopictxt = $convertstr;
					&ToChars($sblasttopictxt);
					&ToChars($sbfulltopictext);

					if ($cliped) { $sblasttopictxt .= "..."; }

					$sblasttopictxt =~ s/  / \&nbsp;/g;
					$sblasttopictxt =~ s/</&lt;/g;
					$sblasttopictxt =~ s/>/&gt;/g;
					$sblasttopictxt =~ s/\|/\&#124;/g;

					$sbfulltopictext =~ s/</&lt;/g;
					$sbfulltopictext =~ s/>/&gt;/g;
					$sbfulltopictext =~ s/\|/\&#124;/g;

					$sblasttopicsubject = $sblasttopictxt;
				}

				if ($sboard{"$curboard"} ne "" && $sblastpost > ${$uid.$curboard}{'lastposttime'}) {
					$lasttopiclink = qq~<a href="$scripturl?num=${$uid.$sblastpostbd}{'lastpostid'}/${$uid.$sblastpostbd}{'lastreply'}#${$uid.$sblastpostbd}{'lastreply'}" title="$sbfulltopictext">$sblasttopicsubject</a>~;
					$lastposter = $sblastposter;
					$lastpostlink = $sblastpostlink;
				} else {
					$lasttopiclink = qq~<a href="$scripturl?num=${$uid.$curboard}{'lastpostid'}/${$uid.$curboard}{'lastreply'}#${$uid.$curboard}{'lastreply'}" title="$fulltopictext">$lasttopictxt</a>~;
				}

				if (${$uid.$curboard}{'threadcount'} < 0)  { ${$uid.$curboard}{'threadcount'}  = 0; }
				if (${$uid.$curboard}{'messagecount'} < 0) { ${$uid.$curboard}{'messagecount'} = 0; }
				$templateblock =~ s/<yabb boardanchor>/$curboard/g;
				$templateblock =~ s/<yabb boardurl>/$scripturl\?board\=$curboard/g;
				$templateblock =~ s/<yabb new>/$new/g;
				$templateblock =~ s/<yabb boardpic>/$bdpic/g;
				$templateblock =~ s/<yabb boardname>/$boardname/g;
				$templateblock =~ s/<yabb boarddesc>/$bddescr/g;
				$templateblock =~ s/<yabb moderators>/$showmods$showmodgroups/g;
				$templateblock =~ s/<yabb subboards>/$subboards/g;
				$templateblock =~ s/<yabb threadcount>/$totalthreadcount{"$curboard"}/g;
				$templateblock =~ s/<yabb messagecount>/$totalmessagecount{"$curboard"}/g;
				$templateblock =~ s/<yabb lastpostlink>/$lastpostlink/g;
				$templateblock =~ s/<yabb lastposter>/$lastposter/g;
				$templateblock =~ s/<yabb lasttopiclink>/$lasttopiclink/g;


				$tmptemplateblock .= $templateblock;
			}
		}
		$tmptemplateblock .= $catfooter;
		++$catcount;
	}

	if (!$iamguest) {
		$ims = @immessages;

		if ($minnum > $numibox && $numibox ne "" && $enable_imlimit == 1) {
			$yymain .= qq~<script language="javascript" type="text/javascript"> if(confirm('$boardindex_imtxt{'11'} $minnum $boardindex_imtxt{'12'} $boardindex_txt{'316'}!\\n$numibox $boardindex_imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
			&Del_Max_IM;
		}

		if ($moutnum > $numobox && $numobox ne "" && $enable_imlimit == 1) {
			$yymain .= qq~<script language="javascript" type="text/javascript"> if(confirm('$boardindex_imtxt{'11'} $moutnum $boardindex_imtxt{'12'} $boardindex_txt{'320'}!\\n$numobox $boardindex_imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
			&Del_Max_IMOUT;
		}

		if ($storenum > $numstore && $numstore ne "" && $enable_imlimit == 1) {
			$yymain .= qq~<script language="javascript" type="text/javascript"> if(confirm('$boardindex_imtxt{'11'} $storenum $boardindex_imtxt{'12'} $boardindex_imtxt{'46'}!\\n$numstore $boardindex_imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
			&Del_Max_STORE;
		}

		$ims = qq~$boardindex_txt{'795'} <a href="$scripturl?action=im"><b>$ims</b></a> $boardindex_txt{'796'}~;
		if ($#immessages > 0) {
			if ($imnewcount == 1) {
				$ims .= qq~ $boardindex_imtxt{'24'} <a href="$scripturl?action=im"><b>$imnewcount</b></a> $boardindex_imtxt{'25'}.~;
			} else {
				$ims .= qq~ $boardindex_imtxt{'24'} <a href="$scripturl?action=im"><b>$imnewcount</b></a> $boardindex_imtxt{'26'}.~;
			}
		} else {
			$ims .= qq~.~;
		}

		if ($INFO{'catselect'} eq '') {
			if ($colbutton) {
				$collapselink = qq~$menusep<a href="$scripturl?action=collapse_all;status=0">$img{'collapse'}</a>~;
			}
			if (${$uid.$username}{'cathide'}) {
				$expandlink = qq~$menusep<a href="$scripturl?action=collapse_all;status=1">$img{'expand'}</a>~;
			}
			$markalllink = qq~$menusep<a href="$scripturl?action=markallasread">$img{'markallread'}</a>~;

		} else {
			$markalllink  = qq~$menusep<a href="$scripturl?action=markallasread;cat=$INFO{'catselect'}">$img{'markallread'}</a>~;
			$collapselink = "";
			$expandlink   = "";
		}
	}
	if ($INFO{'catselect'}) { &jumpto; }

	if ($totalt < 0) { $totalt = 0; }
	if ($totalm < 0) { $totalm = 0; }

	$guestson = qq~<span class="small">$boardindex_txt{'141'}: <b>$guests</b></span>~;
	$userson = qq~<span class="small">$boardindex_txt{'142'}: <b>$numusers</b></span>~;
## start hidden user mod part 4 - show count of hidden users in board index ##
    if($only_admin_gmod_view || $allow_hidden_admin_gmod eq 1){
	   if($allow_hidden eq 1 && ($iamadmin || $iamgmod)) {$hiddenon = qq~<span class="small">$hidden_txt{'3'}: <b>$numhidden</b><br /></span>~;}
	   else {$hiddenon = qq~<!-- no hidden users -->~;}
	}
	elsif($allow_hidden eq 1 &&!$iamguest) {$hiddenon = qq~<span class="small">$hidden_txt{'3'}: <b>$numhidden</b><br /></span>~;}
	else {$hiddenon = qq~<!-- no hidden users -->~;}
	
	$totalusers = $numusers + $guests + $numhidden;
## end hidden user mod part 4 ##

	if (!-e ("$vardir/mostlog.txt")) {
		fopen(MOSTUSERS, ">$vardir/mostlog.txt");
		print MOSTUSERS "$numusers|$date\n";
		print MOSTUSERS "$guests|$date\n";
		print MOSTUSERS "$totalusers|$date\n";
## start hidden user mod part 7 - most hidden users ##
		if($allow_hidden eq 1) {
		   print MOSTUSERS "$numhidden|$date\n";
		}
## end hidden user mod part 7 ##
		fclose(MOSTUSERS);
	}
	fopen(MOSTUSERS, "$vardir/mostlog.txt");
	@mostentries = <MOSTUSERS>;
	fclose(MOSTUSERS);
	($mostmemb,  $datememb)  = split(/\|/, $mostentries[0]);
	($mostguest, $dateguest) = split(/\|/, $mostentries[1]);
	($mostusers, $dateusers) = split(/\|/, $mostentries[2]);
## start hidden user mod part 8.1 - add most hidden users to mostlog.txt ##
	if($allow_hidden eq 1) {($mosthidden, $datehidden) = split(/\|/,$mostentries[3]);}
	chomp $datememb;
	chomp $dateguest;
	chomp $dateusers; 
	if($allow_hidden eq 1) {chomp $datehidden;}
	if($numusers >= $mostmemb || $guests >= $mostguest || $totalusers >= $mostusers || $numhidden >= $mosthidden) {
## end hidden user mod part 8.1 ##
		fopen(MOSTUSERS, ">$vardir/mostlog.txt");
		if ($numusers >= $mostmemb)    { $mostmemb  = $numusers;   $datememb  = $date; }
		if ($guests >= $mostguest)     { $mostguest = $guests;     $dateguest = $date; }
## start hidden user mod mod part 8.2 - add most hidden users to mostlog.txt ##
		if($allow_hidden eq 1) {
		if($numhidden >= $mosthidden) {$mosthidden = $numhidden; $datehidden = $date;}
		}
## end hidden user mod part 8.2 ##
		if ($totalusers >= $mostusers) { $mostusers = $totalusers; $dateusers = $date; }
		print MOSTUSERS "$mostmemb|$datememb\n";
		print MOSTUSERS "$mostguest|$dateguest\n";
		print MOSTUSERS "$mostusers|$dateusers\n";
## start hidden user mod mod part 8.3 - add most hidden users to mostlog.txt ##
		if($allow_hidden eq 1) { print MOSTUSERS "$mosthidden|$datehidden\n"; }
## end hidden user mod part 8.3 ##
		fclose(MOSTUSERS);
	}
	$themostmembdate  = &timeformat($datememb);
	$themostguestdate = &timeformat($dateguest);
	$themostuserdate  = &timeformat($dateusers);
## start hidden user mod part 9 - ready date to be displayed in board index ##
    if($only_admin_gmod_view || $allow_hidden_admin_gmod eq 1){
	   if($allow_hidden eq 1 && ($iamadmin || $iamgmod)) {
	      $mosthidedate = &timeformat($datehidden);
	      $themosthiddendate = qq~$maintxt{'30'} $mosthidedate<br />~;
	   }
	   else {$hiddenon = qq~<!-- no hidden users -->~;}
	}
    elsif ($allow_hidden eq 1 && !$iamguest) {
	   $mosthidedate = &timeformat($datehidden);
	   $themosthiddendate = qq~$maintxt{'30'} $mosthidedate<br />~;}
	else {$themosthiddendate = qq~<!-- no hidden users -->~;}
## end hidden user mod part 9 ##

	$themostuser  = qq~$mostusers~;
	$themostmemb  = qq~$mostmemb~;
	$themostguest = qq~$mostguest~;
## start hidden user mod part 10 - ready users to be displayed in board index ##
    if($only_admin_gmod_view || $allow_hidden_admin_gmod eq 1){
	   if($allow_hidden eq 1 && ($iamadmin || $iamgmod)) {$themosthidden = qq~$hidden_txt{'4'} <b>$mosthidden</b> ~;}
	   else {$hiddenon = qq~<!-- no hidden users -->~;}
	}
	elsif($allow_hidden eq 1 && !$iamguest) {$themosthidden = qq~$hidden_txt{'4'} <b>$mosthidden</b> ~;}
	else {$themosthidden = qq~<!-- no hidden users -->~;}
## end hidden user mod part 10 ##

	my $shared_login;
	if ($iamguest) {
		require "$sourcedir/LogInOut.pl";
		$sharedLogin_title = "";
		$shared_login      = &sharedLogin;
	}

	$grpcolors = "";
	($title, undef, undef, $color, $noshow) = split(/\|/, $Group{'Administrator'}, 5);
	if ($color && $noshow != 1) { $grpcolors .= qq~<div class="small" style="float: left; width: 49%;"><span style="color: $color;"><b>lllll</b></span> $title</div>~; }
	($title, undef, undef, $color, $noshow) = split(/\|/, $Group{'Global Moderator'}, 5);
	if ($color && $noshow != 1) { $grpcolors .= qq~<div class="small" style="float: left; width: 49%;"><span style="color: $color;"><b>lllll</b></span> $title</div>~; }
	foreach $nopostamount (sort { $a <=> $b } keys %NoPost) {
		($title, undef, undef, $color, $noshow) = split(/\|/, $NoPost{$nopostamount}, 5);
		if ($color && $noshow != 1) { $grpcolors .= qq~<div class="small" style="float: left; width: 49%;"><span style="color: $color;"><b>lllll</b></span> $title</div>~; }
	}
	foreach $postamount (sort { $b <=> $a } keys %Post) {
		($title, undef, undef, $color, $noshow) = split(/\|/, $Post{$postamount}, 5);
		if ($color && $noshow != 1) { $grpcolors .= qq~<div class="small" style="float: left; width: 49%;"><span style="color: $color;"><b>lllll</b></span> $title</div>~; }
	}

	# Template it
	$boardindex_template =~ s/<yabb navigation>/$curforumurl/g;
	$boardindex_template =~ s/<yabb selecthtml>/$selecthtml/g;
	$boardindex_template =~ s/<yabb catsblock>/$tmptemplateblock/g;

	$boardhandellist     =~ s/<yabb collapse>/$collapselink/g;
	$boardhandellist     =~ s/<yabb expand>/$expandlink/g;
	$boardhandellist     =~ s/<yabb markallread>/$markalllink/g;
	$boardhandellist     =~ s/\Q$menusep//i;
	$boardindex_template =~ s/<yabb boardhandellist>/$boardhandellist/g;

	$boardindex_template =~ s/<yabb totaltopics>/$totalt/g;
	$boardindex_template =~ s/<yabb totalmessages>/$totalm/g;

	&LoadCensorList;

	if ($Show_RecentBar) {
		$lssub = &Censor($lssub);
		$lssub =~ s/\A\[m\]/$maintxt{'758'}/;
		&ToChars($lssub);
		$tmlsdatetime    = qq~($lsdatetime).<br />~;
		$lastpostlink    = qq~$boardindex_txt{'236'} <b><a href="$scripturl?num=$lspostid/$lsreply#$lsreply"><b>$lssub</b></a></b>~;
		$recentpostslink = qq~$boardindex_txt{'791'} <a href="$scripturl?action=recent">$recent_post_val $acup_dim_txt{'7'}</a> $boardindex_txt{'793'}~;
		$boardindex_template =~ s/<yabb lastpostlink>/$lastpostlink/g;
		$boardindex_template =~ s/<yabb recentposts>/$recentpostslink/g;
		$boardindex_template =~ s/<yabb lastpostdate>/$tmlsdatetime/g;
	} else {
		$boardindex_template =~ s/<yabb lastpostlink>//g;
		$boardindex_template =~ s/<yabb recentposts>//g;
		$boardindex_template =~ s/<yabb lastpostdate>//g;
	}
	$membercountlink = qq~<a href="$scripturl?action=ml"><b>$memcount</b></a>~;
	$boardindex_template =~ s/<yabb membercount>/$membercountlink/g;
	if ($showlatestmember) {
		&LoadUser($latestmember);
		$latestmemberlink = qq~$boardindex_txt{'201'} <a href="$scripturl?action=viewprofile;username=$useraccount{$latestmember}"><b>${$uid.$latestmember}{'realname'}</b></a>.<br />~;
		$boardindex_template =~ s/<yabb latestmember>/$latestmemberlink/g;
	} else {
		$boardindex_template =~ s/<yabb latestmember>//g;
	}
## Start Users Today Mod ##
    require "$sourcedir/users_today_2.pl";
    &users_today;
## End Users Today Mod ##
	$boardindex_template =~ s/<yabb ims>/$ims/g;
	$boardindex_template =~ s/<yabb guests>/$guestson/g;
	$boardindex_template =~ s/<yabb users>/$userson/g;
## start hidden user mod part 5 - add hidden user names and counts to board index ##
    $boardindex_template =~ s/<yabb hidden>/$hiddenon/g;
	$boardindex_template =~ s/<yabb onlinehidden>/$hidden/g;
## end hidden user mod part 5 ##
	$boardindex_template =~ s/<yabb onlineusers>/$users/g;
	$boardindex_template =~ s/<yabb onlineguests>/$guestlist/g;
	$boardindex_template =~ s/<yabb mostmembers>/$themostmemb/g;
	$boardindex_template =~ s/<yabb mostguests>/$themostguest/g;
	$boardindex_template =~ s/<yabb mostusers>/$themostuser/g;
## start hidden user mod part 11 - add most hidden user information to board index ##
	$boardindex_template =~ s/<yabb mosthidden>/$themosthidden/g;
	$boardindex_template =~ s/<yabb mosthiddendate>/$themosthiddendate/g;
## end hidden user mod part 11 ##
	$boardindex_template =~ s/<yabb mostmembersdate>/$themostmembdate/g;
	$boardindex_template =~ s/<yabb mostguestsdate>/$themostguestdate/g;
	$boardindex_template =~ s/<yabb mostusersdate>/$themostuserdate/g;
	$boardindex_template =~ s/<yabb groupcolors>/$grpcolors/g;
## EventCal Begin ##
	if(-e("$vardir/eventcalset.txt"))  { require "$vardir/eventcalset.txt"; }
	if ($Show_EventCal && $EventCal_Active) {
	unless ($iamguest && ($ShowCalendarGuest == 1 || $Show_EventCal == 1)) {
	require "$sourcedir/EventCal.pl";	&get_cal;
	}
	}
## EventCal End ##
	$boardindex_template =~ s/<yabb sharedlogin>/$shared_login/g;

	$yymain .= qq~$boardindex_template~;

	if ($imnewcount > 0) {
		if ($imnewcount > 1) { $en = "s"; $en2 = "$boardindex_imtxt{'47'}"; }
		else { $en = ""; $en2 = "$boardindex_imtxt{'48'}"; }

		chomp(${$uid.$username}{'im_imspop'});
		chomp(${$uid.$username}{'im_popup'});

		if (${$uid.$username}{'im_popup'} eq "on") {
			if (${$uid.$username}{'im_imspop'} eq "on") {
				$yymain .= qq~
	<script language="JavaScript" type="text/javascript">
	function rimpu() { window.open("$scripturl?action=im") }
	function cancel () { }
	</script>~;
			} else {
				$yymain .= qq~
	<script language="JavaScript" type="text/javascript">
	function rimpu() { location.href = ("$scripturl?action=im") }
	function cancel () { }
	</script>~;
			}

			$yymain .= qq~
	<script language="JavaScript" type="text/javascript">
	<!-- BEGIN
		if (confirm("$boardindex_imtxt{'14'} $imnewcount$boardindex_imtxt{'15'}?")) { rimpu(); } else cancel()
	// END -->
	</script>
		~;
		}
	}

	if ($userimcfg[5] eq "on") {
		$yymain .= qq~<script language="javascript" type="text/javascript"> function viewinstant() { window.open("$scripturl?action=im") } </script>~;
	} else {
		$yymain .= qq~<script language="javascript" type="text/javascript"> function viewinstant() { location.href = ("$scripturl?action=im") } </script>~;
	}

	$yytitle = "$boardindex_txt{'18'}";
	&template;
	exit;
}

sub Collapse_Write {
	my @userhide;

	# rewrite the category hash for the user
	foreach my $key (@categoryorder) {
		my ($catname, $catperms, $catallowcol) = split(/\|/, $catinfo{$key});
		$access = &CatAccess($catperms);
		if ($catcol{$key} == 0 && $access) { push(@userhide, $key); }
	}
	${$uid.$username}{'cathide'} = join(",", @userhide);
	&UserAccount($username, "update");
	if (-e "$memberdir/$username.cat") { unlink "$memberdir/$username.cat"; }
}

sub Collapse_Cat {
	if ($iamguest) { &fatal_error($boardindex_exptxt{'4'}); }
	my $changecat = $INFO{'cat'};
	unless ($colloaded) { &Collapse_Load; }

	if ($catcol{$changecat} eq 1) {
		$catcol{$changecat} = 0;
	} else {
		$catcol{$changecat} = 1;
	}
	&Collapse_Write;
	$yySetLocation = qq~$scripturl~;
	&redirectexit;
}

sub Collapse_All {
	my ($state, @catstatus);
	$state = $INFO{'status'};

	if ($iamguest) { &fatal_error($boardindex_exptxt{'4'}); }
	if ($state != 1 && $state != 0) { &fatal_error($boardindex_exptxt{'7'}); }

	foreach my $key (@categoryorder) {
		my ($catname, $catperms, $catallowcol) = split(/\|/, $catinfo{$key});
		if ($catallowcol eq '1') {
			$catcol{$key} = $state;
		} else {
			$catcol{$key} = 1;
		}
	}
	&Collapse_Write;

	$yySetLocation = qq~$scripturl~;
	&redirectexit;
}

sub MarkAllRead {
	unless ($mloaded == 1) { require "$boardsdir/forum.master"; }

  CAT: foreach my $catid (@categoryorder) {
		if ($INFO{'cat'} ne '') {
			if ($INFO{'cat'} eq $catid) {
				$boardlist = $cat{$catid};
				(@bdlist) = split(/\,/, $boardlist);
				($catname, $catperms) = split(/\|/, $catinfo{"$catid"});

				# Category Permissions Check
				$cataccess = &CatAccess($catperms);
				if (!$cataccess) { next; }
			  BOARD: foreach $curboard (@bdlist) {
					chomp $curboard;
					&modlog("$curboard--mark");
					&modlog($curboard);

					next BOARD;
				}
				last CAT;
			} else {
				next CAT;
			}
		} else {
			$boardlist = $cat{$catid};
			(@bdlist) = split(/\,/, $boardlist);
			($catname, $catperms) = split(/\|/, $catinfo{"$catid"});

			# Category Permissions Check
			$cataccess = &CatAccess($catperms);
			if (!$cataccess) { next; }
		  BOARD: foreach $curboard (@bdlist) {
				chomp $curboard;
				&modlog("$curboard--mark");
				&modlog($curboard);
				next BOARD;
			}
		}
	}
	&dumplog;
	$yySetLocation = qq~$scripturl~;
	&redirectexit;
}

sub gostRemove {
	$thecat    = $_[0];
	$gostboard = $_[1];
	unless ($mloaded == 1) { require "$boardsdir/forum.master"; }
	(@gbdlist) = split(/\,/, $cat{$thecat});
	$tmp_master = "";
	foreach $item (@gbdlist) {
		if ($item ne $gostboard) {
			$tmp_master .= qq~$item,~;
		}
	}
	$tmp_master =~ s/,\Z//;
	$cat{$thecat} = qq~$tmp_master~;
	&Write_ForumMaster;
}

1;

